//
//  AppDelegate.m
//  Hallo Taxi
//
//  Created by Holger Hinzberg on 14.02.12.
//  Copyright (c) 2012 Cocoa-Coding. All rights reserved.
//

#import "AppDelegate.h"
#import "TaxiFareCalculator.h"

@implementation AppDelegate

@synthesize window = _window;
@synthesize sliderValueLabel = _sliderValueLabel;
@synthesize isHolidayTourCheckBox = _isHolidayTourCheckBox;
@synthesize isNightTourCheckBox = _isNightTourCheckBox;
@synthesize hasLuggageCheckBox = _hasLuggageCheckBox;
@synthesize taxiFareText = _taxiFareText;

- (void)applicationDidFinishLaunching:
    (NSNotification *)aNotification
{
    fareCalculator = [TaxiFareCalculator new];
}

- (void)awakeFromNib
{
    // Der Schieberegler ist bei Programmstart auf Position 1.
    // Das ist der Wert current im Interface Builder.
    _sliderValueLabel.intValue = 1;
    // Einen Fahrpreis gibt es noch nicht.
    _taxiFareText.stringValue = @"";
}

- (IBAction)sliderMoved:(id)sender
{
    // Ist der sender vom Type NSSlider?
    if ([sender isKindOfClass: [NSSlider class]])
    {
        NSSlider *slider = sender;
        int value = slider.intValue;
        _sliderValueLabel.intValue = value;
        
        // Rechnen
        fareCalculator.kilometer = value;
        double fare = [fareCalculator calculateFare];
                
        // Ergebnis an Label-Steuerelement übergeben.
       _taxiFareText.doubleValue = fare;
    }
}

- (IBAction)checkBoxStateChanged:(id)sender
{
    // Hat schweres Gepäck?
    if ( _hasLuggageCheckBox.state == NSOnState)
    {
        fareCalculator.hasLuggage = YES;
    }
    else
    {
        fareCalculator.hasLuggage = NO;
    }
    
    // Ist es ein Feiertag?
    if ( _isHolidayTourCheckBox.state == NSOnState)
    {
        fareCalculator.isHolidayTour = YES;
    }
    else
    {
        fareCalculator.isHolidayTour = NO;
    }
    
    // Ist es eine Nachtfahrt?
    if ( _isNightTourCheckBox.state == NSOnState)
    {
        fareCalculator.isNightTour = YES;
    }
    else
    {
        fareCalculator.isNightTour = NO;
    }
    
    // Rechnen
    double fare = [fareCalculator calculateFare];
    
    // Ergebnis an Label-Steuerelement übergeben.
    _taxiFareText.doubleValue = fare;
}

@end
