//
//  TaxiFareCalculator.m
//  Hallo Taxi
//
//  Created by Holger Hinzberg on 14.02.12.
//  Copyright (c) 2012 Cocoa-Coding. All rights reserved.
//

#import "TaxiFareCalculator.h"

@implementation TaxiFareCalculator

@synthesize kilometer = _kilometer;
@synthesize isHolidayTour = _isHolidayTour;
@synthesize isNightTour = _isNightTour;
@synthesize hasLuggage = _hasLuggage;
@synthesize delegate = _delegate;

- (id)init
{
    if ((self = [super init]))
    {
        _kilometer = 0;
        _isHolidayTour = NO;
        _isNightTour = NO;
        _hasLuggage = NO;
    }
    return self;
}

-(void)calculateFare
{
    // Der Grundpreis für jede Fahrt
    double fare = 2.50;
    
    // Nachtfahrt oder Feiertag?
    if(_isNightTour == YES ||
       _isHolidayTour == YES)
    {
        fare += _kilometer * 1.45;
    }
    else
    {
        fare += _kilometer * 1.35;
    }
    
    // Mit Gepäck?
    if(_hasLuggage == YES)
    {
        fare += 4.50;
    }
    
    
    // Ergebnis an das Delegate übergeben
    if([_delegate respondsToSelector:
        @selector(calculationDidFinish:)])
    {
        [_delegate calculationDidFinish:fare];
    }
    
    // Hier wird die Nachricht gesendet
    if([_delegate respondsToSelector:
        @selector(protocolTest:)])
    {
        [_delegate protocolTest:fare];
    }


}


@end
