//
//  ViewController.m
//  NavigationStoryboard
//
//  Created by Holger Hinzberg on 04.03.12.
//  Copyright (c) 2012 Cocoa-Coding. All rights reserved.
//

#import "CarDetailViewController.h"
#import "ColorViewController.h"

@interface CarDetailViewController ()

@end

@implementation CarDetailViewController
@synthesize carNameLabel;
@synthesize carColorLabel;
@synthesize carGearboxLabel;
@synthesize car;

- (void)viewDidLoad
{
    [super viewDidLoad];
	[self showCarData];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

-(void) showCarData
{
    if (self.car == NULL)
    {
        self.car = [[Car alloc] init];
    }
    
    carNameLabel.text = self.car.name;
    carColorLabel.text = self.car.color;
    carGearboxLabel.text = self.car.gearbox;
}

- (IBAction)colorChangeButtonClicked:(id)sender
{
    [self performSegueWithIdentifier:
     @"ColorChangeSegue" sender: self];
}

- (IBAction)gearChangeButtonClicked:(id)sender
{
   [self performSegueWithIdentifier: 
    @"GearChangeSegue" sender: self];
}

- (void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    if ([segue.identifier isEqualToString:@"ColorChangeSegue"])
	{
        ColorViewController * colorViewController =
        segue.destinationViewController;
        
        colorViewController.carColor = self.car.color;
        
        // Der Delegate des ColorViewController
        // ist der CarDetailViewController
        colorViewController.delegate = self;
	}
    else if ([segue.identifier isEqualToString:
              @"GearChangeSegue"])
    {
        GearViewController * gearViewController =
        segue.destinationViewController;        
        gearViewController.gear = self.car.gearbox;
        gearViewController.delegate = self;
    }

}

-(void) colorDidChange:(ColorViewController *)controller
{
    self.car.color = controller.carColor;
    [self showCarData];
    
    [self.navigationController
     popViewControllerAnimated:YES];
}

-(void) gearDidChange:(GearViewController *)controller
{
    self.car.gearbox = controller.gear;
    [self showCarData];
    [self.navigationController
     popViewControllerAnimated:YES];
}



@end
